package com.sample;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.w3c.dom.Element;

/**
 * Servlet implementation class Stub
 */
public class Stub extends HttpServlet {
	private static final long serialVersionUID = 1L;

    /**
     * Default constructor. 
     */
    public Stub() {
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		doExecute(request, response);
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		doExecute(request, response);
	}

	private void doExecute(HttpServletRequest request, HttpServletResponse response){
		try {
			XmlUtil util = XmlUtil.getInstance();

			InputStream is = request.getInputStream();
			Element root = util.parse(is);
			String id = util.getId(root);
			Log.debug("HttpXmppStub", id, "RECV", "");
			
			String result = "<iq id=\"" + id + "\" to=\"user02@localhost.localdomain/Smack\" type=\"result\"><query xmlns=\"jabber:iq:register\" /></iq>";
			Log.debug("HttpXmppStub", id, "SEND", result);
			OutputStream os = response.getOutputStream();
			os.write(result.getBytes());
			os.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
